#ifndef snapWin_H
#define snapWin_H
	
	#include <Window.h>
	#include <Button.h>
	#include <TextControl.h>
	#include <String.h>
	#include <MenuField.h>
	#include <PopUpMenu.h>
	#include <List.h>
	
	#include "AutoCompleteTextControl.h"
	#include "myFilter.h"
	
	#define MI_ABOUT 'who?'
	#define MI_ONTOP 'oTOP'
	#define OK 'ok'
	#define CANCEL 'exit'
	#define BROWSE 'find'
	// #define TEXT_ENTER 'entr'
	#define TEXT_EDIT 'chng'
	#define HISTORY_ITEM_CLICK 'hsck'
	// note the XXX_KEY messages are defined in myFilter.h
	// (ENTER_KEY, BACKSPACE_KEY, DELETE_KEY, OTHER_KEY);
	
	class snapWin : public BWindow
	{
		public:
				snapWin();
				~snapWin();
				virtual bool QuitRequested();
				virtual void MessageReceived(BMessage* message);
			// layout functions
				void WHCenter(BRect&);
				void WVCenter(BRect&);
				void GlueRight(BRect&,int space=5);
				void GlueLeft(BRect& ,int space=5);
		private:
				bool IsOnTop;
				BView* view;
				BMenuField* mainMenuField;
						BPopUpMenu* mainPopMenu;
				BButton* okBtn;
						BAlert* errorBox;
				BButton* cancelBtn;
				BButton* browseBtn;
				BFilePanel* filePanel;
				TAutoCompleteTextControl* editbox;
						bool ignore_enter;				
						BTextView* statusbar;
						myFilter* filter;
				BMenuField* historyField;
						BPopUpMenu* historyPopMenu;
			// menuitem events			
				void aboutBox();
				void ontopToggle();
			// button events
				void okBtnClick();
				void browseBtnClick();
				void historyItemClicked();
			// others
				void WindowShadeColor(/*willhaveparams*/);
				void WindowShadeRevert(/*willhaveparams*/);
				void showErrorBox();
				void filePanelClosed(BMessage msg);
	};
#endif
